{$pbe ignore}
unit RunScript;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TPSForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PSForm: TPSForm;

implementation

{$R *.dfm}

{$end pbe ignore}

const
  SND_SYNC            = $0000;  { play synchronously (default) }
  SND_ASYNC           = $0001;  { play asynchronously }
  SND_NODEFAULT       = $0002;  { don't use default sound }
  SND_MEMORY          = $0004;  { lpszSoundName points to a memory file }
  SND_LOOP            = $0008;  { loop the sound until next sndPlaySound }
  SND_NOSTOP          = $0010;  { don't stop any currently playing sound }

  SND_NOWAIT          = $00002000;  { don't wait if the driver is busy }
  SND_ALIAS           = $00010000;  { name is a registry alias }
  SND_ALIAS_ID        = $00110000;  { alias is a predefined ID }
  SND_FILENAME        = $00020000;  { name is file name }
  SND_RESOURCE        = $00040004;  { name is resource name or atom }
  SND_PURGE           = $0040;      { purge non-static events for task }
  SND_APPLICATION     = $0080;      { look for application specific association }

  SND_ALIAS_START             = 0;   { alias base }
  SND_ALIAS_SYSTEMASTERISK    = 'SystemAsterisk'; 
  SND_ALIAS_SYSTEMQUESTION    = 'SystemQuestion'; 
  SND_ALIAS_SYSTEMHAND        = 'SystemHand'; 
  SND_ALIAS_SYSTEMEXIT        = 'SystemExit'; 
  SND_ALIAS_SYSTEMSTART       = 'SystemStart';
  SND_ALIAS_SYSTEMWELCOME     = 'SystemWelcome';
  SND_ALIAS_SYSTEMEXCLAMATION = 'SystemExclamation'; 
  SND_ALIAS_SYSTEMDEFAULT     = 'SystemDefault'; 
    
type
  HINST = THandle;
  HMODULE = HINST;
  DWORD = LongWord;
  BOOL = LongBool;
  
function PlaySound(pszSound: PChar; hmod: HMODULE; fdwSound: DWORD): BOOL; external 'PlaySound@winmm.dll stdcall';

var
  s:string;
  flags:LongWord;
  sk:integer;
begin
  s:='';
  flags:=SND_SYNC;
  sk:=StrToIntDef(GetVariable('FSoundKind.ItemIndex'),-1);
  case sk of
    0:begin
        flags:=flags or SND_FILENAME;
        s := GetVariable('edFileName.Text');
      end;
    1..8:
      begin
        flags:=flags or SND_ALIAS;
        case sk of
          1:s:=SND_ALIAS_SYSTEMASTERISK;              
          2:s:=SND_ALIAS_SYSTEMQUESTION;   
          3:s:=SND_ALIAS_SYSTEMHAND;        
          4:s:=SND_ALIAS_SYSTEMEXIT;        
          5:s:=SND_ALIAS_SYSTEMSTART;       
          6:s:=SND_ALIAS_SYSTEMWELCOME;     
          7:s:=SND_ALIAS_SYSTEMEXCLAMATION;
        else 
            s:=SND_ALIAS_SYSTEMDEFAULT;     
        end;
      end;
  end;

  if length(s)>0 then
  begin  
    if PlaySound(PChar(s), 0, flags) then
      ScriptResult:=SCRIPT_OK
    else
    begin
      ScriptResult:=SCRIPT_ERROR;
      Write('Neznm chyby!');
    end;
  end  
  else
  begin
    ScriptResult:=SCRIPT_ERROR;
    Write('Nen vybrn dn zvuk!');
  end;
end.
